//////////////////////////////////////////////////////////////////////
// scene.cpp: implementation of the scene class.
//
//////////////////////////////////////////////////////////////////////
#include "scene.h"
//////////////////////////////////////////////////////////////////////
void Gula_textur_v_svetlo_1_textura(float gula_polomer,int delenie_guli_sirka,int delenie_guli_dlzka);
static void RotacnaPlocha(int delenie_dlzky,int delenie_uhla);		// vykresli rotacnu plochu okolo osi x

// Tu je vsetko co sa kresli
void scene::DrawGLScene()
{
	static CVector lightp(0, 0, 8);	// pozicia svetla
	static CVector objpos(0, 0, 0);	// pozicia lietadla
	static int mode=ROTATE_WALK|ROTATE_ABOUT_POINT;		// volba modu pre cameru
	if(keys[VK_SPACE])		// menime mod
	{
		switch(mode)
		{
		case ROTATE_WALK: mode=ROTATE_FLY; break;
		case ROTATE_FLY: mode=ROTATE_WALK|ROTATE_ABOUT_POINT; break;
		case ROTATE_WALK|ROTATE_ABOUT_POINT: mode=ROTATE_WALK_2|ROTATE_ABOUT_POINT; break;
		case ROTATE_WALK_2|ROTATE_ABOUT_POINT: mode=ROTATE_FLY|ROTATE_ABOUT_POINT; break;
		case ROTATE_FLY|ROTATE_ABOUT_POINT: mode=ROTATE_WALK; break;
		default: mode=ROTATE_WALK;
		}
		if(mode&ROTATE_ABOUT_POINT)c->set.k_remap_mouse_button_vd_vpd=1;
		else c->set.k_remap_mouse_button_vd_vpd=0;
		c->setKeys();
		c->Reset();			// reset camery
		c->vcp = objpos;	// pretoze sa vcp resetol, nastavyme ho znovu
		keys[VK_SPACE]=0;
	}
	glLoadIdentity();
	c->MoveWorld(fps, mode);	// otoci svetom na zaklade vstupov od mysi a klavesnice
	objpos = c->vcp;		// zmena polovy objektu je odvodena od zmeny polohy stredu
	if(keys['L'] && keys[VK_CONTROL]){ english = !english; keys['L']=0; }
	if(keys['L']){	lightp = c->vp;	keys['L']=0; }		// nastavenie polohy svetla
//	GetCursorPos(&MouseBod);			// pre zobrazenie kurzora
//	mouse_x = MouseBod.x;
//	mouse_y = screen_y-1-MouseBod.y;

	static float lux=0;		// lietadlo uhol okolo x
	static float luy=0;		// lietadlo uhol okolo y
	
	if(!keys['X'])lux += 90.f/fps;		// zvecsujeme uhol
	if(!keys['Y'])luy += 50.f/fps;

	CMatrix4 lm;

	lm.RotY( luy);
	lm.RotX(-lux);
	lm.Translate( 0, 4, 0);

	if(keys['P'])
	{
		c->vp = lm*CVector(0,0,0);
		c->vd = lm*CVector(0,0,-1)-c->vp;
		c->vu = lm*CVector(0,1,0)-c->vp;
		c->vr = lm*CVector(1,0,0)-c->vp;
		c->vp = lm*CVector(0,-3,8);
	}

	// ideme vytvarat cube mapu, pouzivame kreslenie do textury
	glMatrixMode(GL_PROJECTION);		// projekcia
	glLoadIdentity();
	gluPerspective( 90, 1, blizka_orezavacia_rovina, clip_distance);		// 90 stupnov, lebo chceme vykreslit steny kocky
	glMatrixMode(GL_MODELVIEW);
	if(4*renderableTexture<=screen_x || 3*renderableTexture<=screen_y)	// ak sa vojde vsetko na obrazovku
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	//cisti buffer v aktualnom viewporte a to iba color a hlbkovy bit
	unsigned int pos,px,py;
	for(int i=0; i<6; i++)		// cez vsetky steny kocky
	{
		switch(i)		// nastavenie pozicie pre danu cast cubemapy
		{
		case 0: px=3*renderableTexture; py=renderableTexture; break;	// pozerame na -z
		case 1: px=2*renderableTexture; py=renderableTexture; break;	// pozerame na +x
		case 2: px=renderableTexture; py=renderableTexture; break;	// pozerame na +z
		case 3: px=  0; py=renderableTexture; break;	// pozerame na -x
		case 4: px=renderableTexture; py=  0; break;	// pozerame na +y
		case 5: px=renderableTexture; py=2*renderableTexture; break;	// pozerame na -y
		}
		if(4*renderableTexture>screen_x || 3*renderableTexture>screen_y){ px=0; py=0; }	// ak sa nevojde na obrazovku
		glViewport( px, py, renderableTexture, renderableTexture);
		if(4*renderableTexture>screen_x || 3*renderableTexture>screen_y) glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		glLoadIdentity();
		if(i<4)glRotatef(180,0,0,1);
		switch(i)
		{
		case 0: break;							// pozerame na -z
		case 1: glRotatef(90,0,1,0); break;		// pozerame na +x
		case 2: glRotatef(180,0,1,0); break;	// pozerame na +z
		case 3: glRotatef(270,0,1,0); break;	// pozerame na -x
		case 4: glRotatef(-90,1,0,0); break;	// pozerame na +y
		case 5: glRotatef(90,1,0,0); break;		// pozerame na -y
		}
		glTranslatef(-objpos.x, -objpos.y, -objpos.z);	// posunutie stredu do bodu objpos

		glColor3f(1,1,1);
		glEnable(GL_CULL_FACE );
		DrawSkyBox(skybox,15);				// vykreslenie sky boxu
		glDisable(GL_CULL_FACE );
				
		float LightPosition[4]=	{ lightp.x, lightp.y, lightp.z, 1.0f };	// smer difuzneho svetla - ak je 4 zlozka 0 - smerove svetlo
		glLightfv ( GL_LIGHT0, GL_POSITION, LightPosition  );			// pozicia difuzneho svetla

		glPushMatrix();
		lm.glMultMatrix();				// rotacia lietadla
		glEnable(GL_LIGHTING);
		glCallList( lietad);			// kreslime lietadlo
	//	lietadlo->Render();
	//	glDisable(GL_TEXTURE_2D);
	//	glCallList( gula);
		glDisable(GL_LIGHTING);

		glPopMatrix();
		glEnable(GL_TEXTURE_2D);
		{		// svetlo
			CVector s,t,n,p;

			s = 1.0f*c->vr;
			t = 1.0f*c->vu;
			n = -c->vd;
			p = lightp -0.5*s -0.5*t;

			light.glBindTexture2D();
			glBlendFunc(GL_ONE,GL_ONE_MINUS_SRC_COLOR);
			glEnable(GL_BLEND);
			DrawQuad(p,n,s,t);		// kreslime svetlo
			glDisable(GL_BLEND);
		}

		switch(i)					// nastavyme poziciu 
		{
		case 0: pos = GL_TEXTURE_CUBE_MAP_NEGATIVE_Z_ARB; break;	// pozerame na -z
		case 1: pos = GL_TEXTURE_CUBE_MAP_POSITIVE_X_ARB; break;	// pozerame na +x
		case 2: pos = GL_TEXTURE_CUBE_MAP_POSITIVE_Z_ARB; break;	// pozerame na +z
		case 3: pos = GL_TEXTURE_CUBE_MAP_NEGATIVE_X_ARB; break;	// pozerame na -x
		case 4: pos = GL_TEXTURE_CUBE_MAP_POSITIVE_Y_ARB; break;	// pozerame na +y
		case 5: pos = GL_TEXTURE_CUBE_MAP_NEGATIVE_Y_ARB; break;	// pozerame na -y
		}

		glEnable(GL_TEXTURE_CUBE_MAP_ARB);
		glBindTexture(GL_TEXTURE_CUBE_MAP_ARB, cube_map.id);
		glCopyTexSubImage2D( pos, 0, 0, 0, px, py, renderableTexture, renderableTexture );	// skopirujeme
		glDisable(GL_TEXTURE_CUBE_MAP_ARB);
	}
	if(keys[VK_F12] && keys['T'])
	{
	//	SaveScreen_TGA();
		SaveScreen_BMP();
		keys[VK_F12] = 0;
	}
	if(keys['T'])return;				// ak T dalej neprekreslujeme obrazovku

	glViewport(0, 0, sirka, vyska);		// Viewport (pohlad)
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	//cisti buffer v aktualnom viewporte a to iba color a hlbkovy bit
	Prepni_do_3D();						// nastavime povodnu projekcnu maticu
	
	c->SetTransform();					// nastavyme kameru
	float LightPosition[4]=	{ lightp.x, lightp.y, lightp.z, 1.0f };	// smer difuzneho svetla - ak je 4 zlozka 0 - smerove svetlo
	glLightfv ( GL_LIGHT0, GL_POSITION, LightPosition  );	// pozicia difuzneho svetla
	
	lm.glMultMatrix();			// rotacia pre lietadlo
	glEnable(GL_LIGHTING);		// povolime svetlo
//	lietadlo->Render();
	glCallList( lietad);
//	glScalef(0.3f,0.3f,0.3f);
//	glEnable( GL_NORMALIZE );
//	glCallList( gula);
//	glDisable( GL_NORMALIZE );
	glDisable(GL_LIGHTING);
	glColor3f(1,1,1);

	c->SetTransform();				// nastavyme kameru
	// potrebujeme rotovat zrkadlovy povrch
	// zrkadlovy povrch sa nerotuje podla modelovacej matice, rotuje sa projekcnou maticou
	// preto si musime vytvorit rotacnu maticu, ktora nam bude rotavat povrch
	// projekcnu maticu vynasobime touto maticou z prava (normalne glMultMatrix)
	// aby, tato rotacna matica nemala vplyv na modelovaciu maticu
	// modelovaciu maticu vynasobime z LAVA, inverznou rotacnou maticou
	c->MoveToCentralPoint();		// == glTranslatef( objpos.x, objpos.y, objpos.z);
	CMatrix4 m,m1;
	m.glGetMatrix();
	// anulujeme posunutie
	m.m14 = 0;	m.m24 = 0;	m.m34 = 0;	m.m44 = 1;

	glMatrixMode( GL_PROJECTION );
	glPushMatrix();
	glMultMatrixf( m.m);		// zmena projekcnej matice - tymto sa rotuje zrkadlovy odraz na objekte
	glMatrixMode( GL_MODELVIEW );

	m=!m;	// urobime inverznu maticu m

	m1.glGetMatrix();		// ziskame modelovaciu maticu
	m1 = m*m1;				// modelovaciu maticu vynasobime z LAVA, inverznou rotacnou maticou
	m1.glSetMatrix();		// nastavime novu maticu

	// povolime generovanie texturovych suradnic, suradnice sa generuju podla normalovych vektorov
	glTexGenf(GL_S, GL_TEXTURE_GEN_MODE, GL_REFLECTION_MAP_ARB);
	glTexGenf(GL_T, GL_TEXTURE_GEN_MODE, GL_REFLECTION_MAP_ARB);
	glTexGenf(GL_R, GL_TEXTURE_GEN_MODE, GL_REFLECTION_MAP_ARB);
	glEnable(GL_TEXTURE_GEN_S);
	glEnable(GL_TEXTURE_GEN_T);
	glEnable(GL_TEXTURE_GEN_R);
	
	cube_map.glBindTextureCube();		// nastavyme cubemap texturu, ktoru sme si pred chvilkou vyrenderovali
	glDisable(GL_TEXTURE_1D);
	glDisable(GL_TEXTURE_2D);
	glEnable(GL_TEXTURE_CUBE_MAP_ARB);

	static char cokreslim=2;
	if(keys['1'])cokreslim=1;
	else if(keys['2'])cokreslim=2;
	else if(keys['3'])cokreslim=3;
	else if(keys['4'])cokreslim=4;
	else if(keys['5'])cokreslim=5;
	else if(keys['6'])cokreslim=6;
	else if(keys['7'])cokreslim=7;
	else if(keys['8'])cokreslim=8;

	switch(cokreslim)		// vykreslime zrkadlovy objekt
	{
	case 1: glCallList( gula); break;
	case 2: glCallList( cajnik); break;
	case 3: glCallList( anuloid); break;
	case 4: glCallList( lietad); glColor3f(1,1,1); break;
	case 5: DrawSkyBox(skybox,1); break;
	case 6: teapot->Render(2); break;
	case 7: RotacnaPlocha(40,80); break;
	case 8: Gula_textur_v_svetlo_1_textura(3.f, 20, 40); break;
	default: glCallList( cajnik);
	}

	// vypneme generovanie tex. suradnic
	glDisable(GL_TEXTURE_CUBE_MAP_ARB);
	glDisable(GL_TEXTURE_GEN_S);
	glDisable(GL_TEXTURE_GEN_T);
	glDisable(GL_TEXTURE_GEN_R);
	
	glMatrixMode( GL_PROJECTION );
	glPopMatrix();						// vratime projekcnu na povodnu
	glMatrixMode( GL_MODELVIEW );

	c->SetTransform();			// nastavyme kameru
	glEnable( GL_TEXTURE_2D);
	glEnable(GL_CULL_FACE );	// zapnemu orezavanie trojuholnikov kreslenych v smere hodinovych ruciciek glCullFace( GL_BACK );
	DrawSkyBox(skybox,15);		// vykresliem skybox
	glDisable(GL_CULL_FACE );
	
	{	// svetlo
		CVector s,t,n,p;

		s = 1.0f*c->vr;
		t = 1.0f*c->vu;
		n = -c->vd;
		p = lightp -0.5*s -0.5*t;

		light.glBindTexture2D();
		glBlendFunc(GL_ONE,GL_ONE_MINUS_SRC_COLOR);
		glEnable(GL_BLEND);
		DrawQuad(p,n,s,t);
		glDisable(GL_BLEND);
	}

	glColor4f(1,1,1,1);
//	glLoadIdentity();
//	glDisable(GL_TEXTURE_2D);
//	Kurzor();

	font0->Begin();
	fps = 1.0f / timer0.GetTime();
	timer0.Reset();
	fps_counter.GetAvgFps(1.f/fps,0.2f);
	gcvt( (double)fps_counter.avg_fps, 4, text);
	font0->Print(0,0,text,0);

	if(keys[VK_F12])
	{
	//	SaveScreen_TGA();
		SaveScreen_BMP();
		keys[VK_F12] = 0;
	}


	static unsigned char q3mode=1;
	if(keys['M'])
	{
		if(q3mode)c->set_3ds_mouse_style();
		else c->set_q3_mouse_style();
		q3mode=!q3mode;
		keys['M']=0;
	}
	if(q3mode)font0->Print(72-20,0,"q3",0);
	else font0->Print(72-20,0,"3ds",0);

	switch(mode)
	{
	case ROTATE_WALK: font0->Print(72-4,0,"WALK",0); break;
	case ROTATE_FLY: font0->Print(72-3,0,"FLY",0); break;
	case ROTATE_WALK|ROTATE_ABOUT_POINT: font0->Print(72-12,0,"WALK & STRED",0); break;
	case ROTATE_WALK_2|ROTATE_ABOUT_POINT: font0->Print(72-14,0,"WALK 2 & STRED",0); break;
	case ROTATE_FLY|ROTATE_ABOUT_POINT: font0->Print(72-11,0,"FLY & STRED",0); break;
	default: font0->Print(0,0,"WALK",0);
	}

	if(keys['H'])							// zobrazenie helpu
	{
		int i=1;
		glDisable(GL_TEXTURE_2D);
		glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
		glColor4f(0,0,0,0.6f);
		glLoadIdentity();
		glBegin(GL_QUADS);
			glVertex2i(0,0);
			glVertex2i(800,0);
			glVertex2i(800,600-16);
			glVertex2i(0,600-16);
		glEnd();
		glColor4f(1,1,1,1);
		glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_COLOR);
		glEnable(GL_TEXTURE_2D);

		if(english)
		{
			font0->Print(15,i++,"Program: Dynamicky cubemapping",0);
			glColor3f(0.9f,0.9f,1.0f);
			font0->Print(8,i++,"Programmer: Marek Mizanin - www.mizanin.szm.sk",0);
			glColor3f(1.0f,1.0f,1.0f);
			font0->Print(10,i++,"Controls:",0);
			font0->Print(2,i++,"T - show rendered textures",1);
			font0->Print(2,i++,"1,2,3,4,5 - change mirror object",1);
			font0->Print(2,i++,"space - change type of camera",1);
			font0->Print(2,i++,"L - set position of light for plane",1);
			font0->Print(2,i++,"P - move camera behind plane",1);
			font0->Print(2,i++,"X,Y - stop relevant plane spin",1);
			font0->Print(2,i++,"F12 - take screenshot",1);
			font0->Print(2,i++,"M - change ot mode of mouse (q3, 3ds)",1);
			i++;
			font0->Print(2,i++,"Type of camera:",0);
			font0->Print(2,i++,"WALK - classical as in majority games example: Quake 3",1);
			font0->Print(2,i++,"FLY - completely free rotation",1);
		//	font0->Print_scale(2,i++,"    - nemame stabilne hore a dole, pri rotacii sa otacame aj okolo osi z",1,0.95f,1);
			font0->Print_scale(2,i++,"WALK & STRED - rotation about moving center, can change distance from center",1,0.8f,1);
		//	font0->Print(2,i++,"          - pri otacani sme blokovany nemozme prekrocit os y",1);
			font0->Print_scale(2,i++,"WALK 2 & STRED - similarly as previous with difference, that axis y can exceed",1,0.8f,1);
			font0->Print(2,i++,"FLY & STRED - free rotation about moving center",1);
			i++;
			font0->Print(2,i++,"Controls of camera:",0);
			font0->Print_scale(2,i++,"W,S,arrow up,down,left and right button (q3 mode) - move forward and backward",1,0.94f,1);
			font0->Print(2,i++,"A,D,Delete,Insert - move left and right",1);
			font0->Print(2,i++,"Home,End - move up and down",1);
			font0->Print(2,i++,"arrow right,left and moving mouse <-> - rotation about y axis",1);
			font0->Print(2,i++,"Page Up, Page Down a moving mouse | - rotation about x axis",1);
			font0->Print(2,i++,"E,Q -rotation about z axis, only in FlyRotate",1);
			font0->Print_scale(2,i++,"+ and - on numeric. and button (q3 mode) - change distance to center, if rot. about center",1,0.75f,1);
			font0->Print(2,i++,"Shift - slow moving",1);
			font0->Print(2,i++,"R - reset camera",1);
			font0->Print(2,i++,"in 3ds mode mouse:",1);
			font0->Print(2,i++,"left button - rotation about x and y",1);
			font0->Print(2,i++,"right button - move horizontaly and vertikalny",1);
			font0->Print(2,i++,"both button - move forward and backward, raotation about z axis (FLY)",1);
			font0->Print(2,i++,"wheel - change distance to center",1);

		}
		else
		{
			font0->Print(15,i++,"Program: Dynamicky cubemapping",0);
			glColor3f(0.9f,0.9f,1.0f);
			font0->Print(8,i++,"Naprogramoval: Marek Mizanin - www.mizanin.szm.sk",0);
			glColor3f(1.0f,1.0f,1.0f);
			font0->Print(10,i++,"Pouzivane klavesy:",0);
			font0->Print(2,i++,"T - zobrazy vyrenderovane textury",1);
			font0->Print(2,i++,"1,2,3,4,5 - meni zrkadlovy objekt",1);
			font0->Print(2,i++,"medzernik - meni typ kamery",1);
			font0->Print(2,i++,"L - nastavy polohu svetla pre lietadlo",1);
			font0->Print(2,i++,"P - presunie kameru za lietadlo",1);
			font0->Print(2,i++,"X,Y - zastavy prislusnu rotaciu lietadla",1);
			font0->Print(2,i++,"F12 - urobi screenshot",1);
			font0->Print(2,i++,"M - zmena rezimu mysi (q3, 3ds)",1);
			i++;
			font0->Print(2,i++,"Typy kamery:",0);
			font0->Print(2,i++,"WALK - klasicka ako vo vacsine hier napr. Quake 3",1);
			font0->Print(2,i++,"FLY - uplne volne rotacie, niesme blokovany ziadnou osou",1);
			font0->Print_scale(2,i++,"    - nemame stabilne hore a dole, pri rotacii sa otacame aj okolo osi z",1,0.95f,1);
			font0->Print_scale(2,i++,"WALK & STRED - rotacia okolo pohybliveho stredu, mozme menit vzdialemnost od stredu",1,0.8f,1);
			font0->Print(2,i++,"          - pri otacani sme blokovany nemozme prekrocit os y",1);
			font0->Print_scale(2,i++,"WALK 2 & STRED - podobne ako predchadzajuca s tym rozdielom, ze os y mozme prekrocit",1,0.8f,1);
			font0->Print(2,i++,"FLY & STRED - volna rotacia okolo pohybliveho stredu",1);
			i++;
			font0->Print(2,i++,"Ovladanie kamery:",0);
			font0->Print_scale(2,i++,"W,S,sipka hore,dole,lave a prave tlacitko (q3 mod) - pohyb dopredu a dozadu",1,0.94f,1);
			font0->Print(2,i++,"A,D,Delete,Insert - pohyb do boka vlavo vpravo",1);
			font0->Print(2,i++,"Home,End - pohyb hore, dole",1);
			font0->Print(2,i++,"sipka vpravo,vlavo a pohyb mysov <->  - rotacia okolo osi y",1);
			font0->Print(2,i++,"Page Up, Page Down a pohyb mysov | - rotacia okolo osi x",1);
			font0->Print(2,i++,"E,Q - rotacia okolo osi z, iba pri FlyRotate",1);
			font0->Print_scale(2,i++,"+ a - na num. klav. a tlacitka (q3 mod) - zmena vzdialenosti k stredu, pri rot. okolo stredu",1,0.75f,1);
			font0->Print(2,i++,"Shift - pomalsi pohyb",1);
			font0->Print(2,i++,"R - reset kamery",1);
			font0->Print(2,i++,"V 3ds mode mysi:",1);
			font0->Print(2,i++,"lave tlacitko - rotacie okolo x a y",1);
			font0->Print(2,i++,"prave tlacitko - posun horizontaly a vertikalny",1);
			font0->Print(2,i++,"obidve tlacitka - posun do predu a dozadu, rotacia okolo osi z (FLY)",1);
			font0->Print(2,i++,"koliesko - priblizovanie a vzdialovanie od stredu",1);
		}
	}
	font0->End();
}

void scene::BuildDisplayLists()
{
	// lietad - lietadlo
	if(lietad)glDeleteLists(lietad,1);			// ak je vybudovany zmas
	lietad=glGenLists(1);							// generuj 1 novy prazny Dispay List
	glNewList(lietad,GL_COMPILE);					// start noveho Display Listu
	lietadlo->Render();
	glEndList();			//koniec display listu
	// cajnik,anuloid,gula
	if(cajnik)glDeleteLists(cajnik,1);			// ak je vybudovany zmas
	cajnik=glGenLists(1);							// generuj 1 novy prazny Dispay List
	glNewList(cajnik,GL_COMPILE);					// start noveho Display Listu
	teapot->Render(2);
	glEndList();			//koniec display listu
	// anuloid
	if(anuloid)glDeleteLists(anuloid,1);			// ak je vybudovany zmas
	anuloid=glGenLists(1);							// generuj 1 novy prazny Dispay List
	glNewList(anuloid,GL_COMPILE);					// start noveho Display Listu
	RotacnaPlocha(40,80);
	glEndList();			//koniec display listu
	// gula
	if(gula)glDeleteLists(gula,1);			// ak je vybudovany zmas
	gula=glGenLists(1);							// generuj 1 novy prazny Dispay List
	glNewList(gula,GL_COMPILE);					// start noveho Display Listu
	Gula_textur_v_svetlo_1_textura(3.f, 20, 40);
	glEndList();			//koniec display listu
}

struct XYZ{ float x,y,z;};
inline void Normalise(XYZ *p)
{
	float length;

	length = (float) sqrt(p->x * p->x + p->y * p->y + p->z * p->z);
	if (length != 0) {
		p->x /= length;
		p->y /= length;
		p->z /= length;
	} else {
		p->x = 0;
		p->y = 0;
		p->z = 0;
	}
}
void Gula_textur_v_svetlo_1_textura(float gula_polomer,int delenie_guli_sirka,int delenie_guli_dlzka)
{
	float	sirka;		// sirka je vo zvislom smere, moze byt severna, alebo juzna
	float	dlzka;		// dlzka je vo vodorovnom smere, moze byt vychodna, alebo zapadna
	int		i_sirka, i_dlzka;	// index sirky a dlzky
	float	u,v0,v1;		// suradnice na texture
	XYZ		b[2],normal;	// suradnice vypocitanych bodov
	double	velkost_casti_sirky,velkost_casti_dlzky;
	double	polomer_pre_sirku0,polomer_pre_sirku1;	// polomer pre danu sirku

	velkost_casti_sirky = 1.0/(double)delenie_guli_sirka;
	velkost_casti_dlzky = 1.0/(double)delenie_guli_dlzka;
	
	for(i_sirka=-delenie_guli_sirka; i_sirka<delenie_guli_sirka; i_sirka++) // ideme od 0 stupnov do < ako 90.0
	{
		sirka = (float)( i_sirka*90.0*velkost_casti_sirky );	// vypocet uhlu pre dany index
		v0 = (float)(0.5*(i_sirka+delenie_guli_sirka)*velkost_casti_sirky);			// vypocet prislusnej texturovej koordinacie
		v1 = (float)(0.5*(i_sirka+delenie_guli_sirka+1)*velkost_casti_sirky);		// dalsia texturova koordinacia

		polomer_pre_sirku0 = gula_polomer*cos(PI180*sirka);
		polomer_pre_sirku1 = gula_polomer*cos(PI180*(sirka+90.0*velkost_casti_sirky));
		b[0].y = (float)( gula_polomer*sin(PI180*sirka) );
		b[1].y = (float)( gula_polomer*sin(PI180*(sirka+90.0*velkost_casti_sirky)) );

		b[0].x = 0.0f;
		b[1].x = 0.0f;

		b[0].z = (float)( polomer_pre_sirku0 );
		b[1].z = (float)( polomer_pre_sirku1 );
		u = 0.0;								// vypocet prislusnej texturovej koordinacie

		glBegin( GL_TRIANGLE_STRIP);			// kreslim pas trojuholnikov
		
		normal = b[0];
		Normalise( &normal);
		glNormal3fv((float*)&normal);
		glTexCoord2f(u,v0);
		glVertex3fv((float*)&b[0]);
		
		normal = b[1];
		Normalise( &normal);
		glNormal3fv((float*)&normal);
		glTexCoord2f(u,v1);
		glVertex3fv((float*)&b[1]);

		for(i_dlzka=1; i_dlzka<=delenie_guli_dlzka; i_dlzka++) // ideme od o jeden viac ako 0 stupnov po 90.0
		{
			dlzka = (float)( i_dlzka*360.0*velkost_casti_dlzky );	// vypocet uhlu pre dany index
			u = (float)( i_dlzka*velkost_casti_dlzky );				// vypocet prislusnej texturovej koordinacie

			b[0].x = (float)( polomer_pre_sirku0*sin(PI180*dlzka) );
			b[1].x = (float)( polomer_pre_sirku1*sin(PI180*dlzka) );

			b[0].z = (float)( polomer_pre_sirku0*cos(PI180*dlzka) );
			b[1].z = (float)( polomer_pre_sirku1*cos(PI180*dlzka) );

			normal = b[0];
			Normalise( &normal);
			glNormal3fv((float*)&normal);
			glTexCoord2f(u,v0);
			glVertex3fv((float*)&b[0]);
			
			normal = b[1];
			Normalise( &normal);
			glNormal3fv((float*)&normal);
			glTexCoord2f(u,v1);
			glVertex3fv((float*)&b[1]);
		}
		glEnd();
	}
}

static inline void RiadiacaKrivka(float t,float *bod)			// t je z intervalu 0 <= t <= 1
{
	bod[2]=0;
								// anuloid
	t = t * 360 * PI180;			// 0 <= t <= 2pi
	bod[0] =-(float) cos(t);
	bod[1] = (float) sin(t) + 2;
	bod[2] = 1.f;							// vyskusaj zmenit
	
//	bod[0] =-3 * (float) cos(t);
//	bod[1] = 2 * (float) sin(t);
//	bod[2] = 0;							// vyskusaj zmenit
}

static void RotacnaPlocha(int delenie_dlzky,int delenie_uhla)		// vykresli rotacnu plochu okolo osi x
{
/*
uhol	t0=				smerovy vektor	t1=				smerovy vektor	t2=
5		bod0[5][]	->	norm0[5][]		bod1[5][]	->	norm1[5][]		bod2[5][]

0		bod0[0][]	->	norm0[0][]		bod1[0][]	->	norm1[0][]		bod2[0][]
1		bod0[1][]	->	norm0[1][]		bod1[1][]	->	norm1[1][]		bod2[1][]
2		bod0[2][]	->	norm0[2][]		bod1[2][]	->	norm1[2][]		bod2[2][]
3		bod0[3][]	->	norm0[3][]		bod1[3][]	->	norm1[3][]		bod2[3][]
4		bod0[4][]	->	norm0[4][]		bod1[4][]	->	norm1[4][]		bod2[4][]
5		bod0[5][]	->	norm0[5][]		bod1[5][]	->	norm1[5][]		bod2[5][]

najprv	vypocitame vsetky body
potom	napr.: z bodov:				vypocitame normalovy vektor prislusneho stvorca
bod0[0][]				bod1[0][]				bod2[0][]
			norm0[0][]				norm1[0][]
bod0[1][]				bod1[1][]				bod2[1][]
			norm0[1][]				norm1[1][]
bod0[2][]				bod1[2][]				bod2[2][]
			norm0[2][]				norm1[2][]
bod0[3][]				bod1[3][]				bod2[3][]

a potom vypocitame vyhladene normalove vektory pre kazdy bod z pola bodov 0 a 1
norm0[0][]				norm1[0][]
			vnorm1[1][]			--	vyhladeny normalovy vektor pre bod1[1][] 
norm0[1][]				norm1[1][]

normalove vektory pre body bod[x][0][] vypocitame :
							norm0[0][]
				vnorm0[1][]			--	vyhladeny normalovy vektor pre bod0[1][] 
							norm0[1][]
*/
	float	(*bod0)[3];		// smernik na pole vrcholov, pricom vrchol ma 3 suradnice (je pole 3 suradnic)
	float	(*bod1)[3];		// -- "" --
	float	(*bod2)[3];		// -- "" --
	float	(*pomocny)[3];	// pomocny smernik pouzity pri vymene smernikov
	float	(*text_x);		// smernika na pole x suradnic textur
	float	text_y[2];		// dve hodnoty y suradnic textur
	float	(*norm0)[3];		// normalovy vektor plochy
	float	(*norm1)[3];
	float	(*vnorm0)[3];		// vyhladeny normalovy vektor plochy
	float	(*vnorm1)[3];
	float	a[3],b[3],absolut;	// a,b - vektory, absolut - absolutna hodnota vektora
	int		i,j=0;				// indexove premenne
	float	uhol;				// uhol zvecsujuci sa v smere pravotocivej skrutky tociacej sa v smere x osi  ( pri normalnom pohlade uhos sa zvecsuje smerum k nam )
	float	t0,t1,t2;			// t - parameter
	float	krivka0[3],krivka1[3],krivka2[3];		// hodnoty vratene funkciou RiadiacaKrivka();
	
	bod0  = new float[delenie_uhla][3];			// alokacia pamete pre pole vrcholov
	bod1  = new float[delenie_uhla][3];
	bod2  = new float[delenie_uhla][3];
	norm0 = new float[delenie_uhla][3];
	norm1 = new float[delenie_uhla][3];
	vnorm0= new float[delenie_uhla][3];
	vnorm1= new float[delenie_uhla][3];
	text_x= new float[delenie_uhla];

	t0 = 0;				// ( (float) j / (float) delenie_dlzky );
	RiadiacaKrivka(t0,krivka0);
	text_y[0]=1-t0;				// parametru t=0 prinalezi vrch obrazka ( suradnica y=1)
	t1 = 1.0f / (float) delenie_dlzky;
	RiadiacaKrivka(t1,krivka1);
	text_y[1]=1-t1;
	t2 = 2.0f / (float) delenie_dlzky;
	RiadiacaKrivka(t2,krivka2);

	for(i=0;i<delenie_uhla;i++)
	{
		uhol = PI180 * 360.0f * ( (float) i / (float) delenie_uhla );
		text_x[i]  = 1.0f - (float) i / (float) delenie_uhla;
		// pre uhol=0 prava strana obrazka, pre zvecsujuci sa uhol postupujeme z pravej strany k lavej, pre uhol=360 lava strana obrazku
		
		// vypocet poli bodov, su to vlastne body na kruznici, pricom bod0 ma nizsiu x suradnicu, bod1 , ma najvecsiu x suradnicu bod2
		bod0[i][0] = krivka0[0];
		bod0[i][1] = krivka0[1] * (float) cos( uhol ) - krivka0[2] * (float) sin( uhol );
		bod0[i][2] = krivka0[1] * (float) sin( uhol ) + krivka0[2] * (float) cos( uhol );

		bod1[i][0] = krivka1[0];
		bod1[i][1] = krivka1[1] * (float) cos( uhol ) - krivka1[2] * (float) sin( uhol );
		bod1[i][2] = krivka1[1] * (float) sin( uhol ) + krivka1[2] * (float) cos( uhol );
		
		bod2[i][0] = krivka2[0];
		bod2[i][1] = krivka2[1] * (float) cos( uhol ) - krivka2[2] * (float) sin( uhol );
		bod2[i][2] = krivka2[1] * (float) sin( uhol ) + krivka2[2] * (float) cos( uhol );
	}

	for(i=0;i<delenie_uhla;i++)		// vypocet normalovych vektorov stvorcov v pase medzi nultov a prvou kruznicou
	{
		if(i == (delenie_uhla-1) )
		{	// vypocet vektora							 bod0[i]   bod1[i]
			a[0] = bod1[0][0] - bod1[i][0];				//	+----->
			a[1] = bod1[0][1] - bod1[i][1];				//	 b    |
			a[2] = bod1[0][2] - bod1[i][2];				//	      |
		}												//	    a v   bod1[i+1]
		else		// bod1[delenie_uhla]=bod1[0];
		{
			a[0] = bod1[i+1][0] - bod1[i][0];
			a[1] = bod1[i+1][1] - bod1[i][1];
			a[2] = bod1[i+1][2] - bod1[i][2];
		}
	
		b[0] = bod1[i][0] - bod0[i][0];
		b[1] = bod1[i][1] - bod0[i][1];
		b[2] = bod1[i][2] - bod0[i][2];
	
		norm0[i][0] = a[1]*b[2] - a[2]*b[1];		// vektorovy sucin vektorov a, b
		norm0[i][1] = a[2]*b[0] - a[0]*b[2];		// vysledok je vektor kolmy na obidve vektory (a,b)
		norm0[i][2] = a[0]*b[1] - a[1]*b[0];		// vysledok je normalovy vektor stvorca bod0[i+1], bod1[i+1], bod1[i], bod0[i]
		// vypocet velkosti vektora
		absolut = (float) sqrt(norm0[i][0]*norm0[i][0]+norm0[i][1]*norm0[i][1]+norm0[i][2]*norm0[i][2]);
		if(absolut>0)		// zabezpecenie proti deleniu nulov
		{
			norm0[i][0] = norm0[i][0]/absolut;		// urobime z normaloveho vektora jednotkovy (z velkostou 1)
			norm0[i][1] = norm0[i][1]/absolut;
			norm0[i][2] = norm0[i][2]/absolut;
		}
	}

	for(i=0;i<delenie_uhla;i++)		// vypocet normalovych vektorov stvorcov v pase medzi prvou a druhou kruznicou
	{
		if(i == (delenie_uhla-1) )
		{	// vypocet vektora					 bod1[i]  bod2[i]
			a[0] = bod1[0][0] - bod1[i][0];		//	+----->
			a[1] = bod1[0][1] - bod1[i][1];		//	|     b
			a[2] = bod1[0][2] - bod1[i][2];		//	|
		}										//	V a -bod1[i+1]
		else
		{
			a[0] = bod1[i+1][0] - bod1[i][0];
			a[1] = bod1[i+1][1] - bod1[i][1];
			a[2] = bod1[i+1][2] - bod1[i][2];
		}
	
		b[0] = bod2[i][0] - bod1[i][0];
		b[1] = bod2[i][1] - bod1[i][1];
		b[2] = bod2[i][2] - bod1[i][2];
	
		norm1[i][0] = a[1]*b[2] - a[2]*b[1];		// vektorovy sucin vektorov a, b
		norm1[i][1] = a[2]*b[0] - a[0]*b[2];		// vysledok je vektor kolmy na obidve vektory (a,b)
		norm1[i][2] = a[0]*b[1] - a[1]*b[0];		// vysledok je normalovy vektor stvorca bod1[i+1], bod2[i+1], bod2[i], bod1[i]
		// vypocet velkosti vektora
		absolut = (float) sqrt(norm1[i][0]*norm1[i][0]+norm1[i][1]*norm1[i][1]+norm1[i][2]*norm1[i][2]);
		if(absolut>0)		// zabezpecenie proti deleniu nulov
		{
			norm1[i][0] = norm1[i][0]/absolut;		// urobime z normaloveho vektora jednotkovy (z velkostou 1)
			norm1[i][1] = norm1[i][1]/absolut;
			norm1[i][2] = norm1[i][2]/absolut;
		}
	}

	//  TERAZ vypocitame vyhladene normalove vektory, a to tak, ze vyhladeny vektor pre bod 
	//	medzi styrmi stvorcami vypocitame ako aritmeticky priemer okolitych normalovych vektorov
	//	normalove vektory pre body bod[x][0][] vypocitame :
	//							norm0[0][]
	//				vnorm0[1][]			--	vyhladeny normalovy vektor pre bod0[1][] 
	//							norm0[1][]
	for(i=1;i<delenie_uhla;i++)			// vypocet vyhladenych normalovych vektorov
	{
		vnorm0[i][0]=( norm0[i-1][0] + norm0[i][0] )/3.0f;
		vnorm0[i][1]=( norm0[i-1][1] + norm0[i][1] )/3.0f;
		vnorm0[i][2]=( norm0[i-1][2] + norm0[i][2] -1.0f)/3.0f;
	}
	vnorm0[0][0]=( norm0[delenie_uhla-1][0] + norm0[0][0] )/3.0f;
	vnorm0[0][1]=( norm0[delenie_uhla-1][1] + norm0[0][1] )/3.0f;
	vnorm0[0][2]=( norm0[delenie_uhla-1][2] + norm0[0][2] -1.0f)/3.0f;
/*	for(i=1;i<delenie_uhla;i++)			// vypocet vyhladenych normalovych vektorov
	{
		vnorm0[i][0]=( norm0[i-1][0] + norm0[i][0] )/2.0f;
		vnorm0[i][1]=( norm0[i-1][1] + norm0[i][1] )/2.0f;
		vnorm0[i][2]=( norm0[i-1][2] + norm0[i][2] )/2.0f;
	}
	vnorm0[0][0]=( norm0[delenie_uhla-1][0] + norm0[0][0] )/2.0f;
	vnorm0[0][1]=( norm0[delenie_uhla-1][1] + norm0[0][1] )/2.0f;
	vnorm0[0][2]=( norm0[delenie_uhla-1][2] + norm0[0][2] )/2.0f;
*/
	//	norm0[0][]				norm1[0][]
	//				vnorm1[1][]			--	vyhladeny normalovy vektor pre bod1[1][] 
	//	norm0[1][]				norm1[1][]
	for(i=1;i<delenie_uhla;i++)			// vypocet vyhladenych normalovych vektorov
	{
		vnorm1[i][0]=( norm0[i-1][0] + norm0[i][0] + norm1[i-1][0] + norm1[i][0] )/4.0f;
		vnorm1[i][1]=( norm0[i-1][1] + norm0[i][1] + norm1[i-1][1] + norm1[i][1] )/4.0f;
		vnorm1[i][2]=( norm0[i-1][2] + norm0[i][2] + norm1[i-1][2] + norm1[i][2] )/4.0f;
	}
	vnorm1[0][0]=( norm0[delenie_uhla-1][0] + norm0[0][0] + norm1[delenie_uhla-1][0] + norm1[0][0] )/4.0f;
	vnorm1[0][1]=( norm0[delenie_uhla-1][1] + norm0[0][1] + norm1[delenie_uhla-1][1] + norm1[0][1] )/4.0f;
	vnorm1[0][2]=( norm0[delenie_uhla-1][2] + norm0[0][2] + norm1[delenie_uhla-1][2] + norm1[0][2] )/4.0f;

	glBegin(GL_QUADS);			// kreslime stvorce
	for(i=0;i<(delenie_uhla-1);i++)		// kresime prvy pas stvorcov z lava
	{

		glNormal3fv( vnorm0[i+1] );				// normalovy vektor pre prvy bod v stvorci
		glTexCoord2f(text_x[i+1],text_y[0]);	// texturove suradnice pre prvy bod v stvorci
		glVertex3fv(   bod0[i+1] );				// prvy bod v stvorci - je v lavo dolnom rohu stvorca 
		glNormal3fv( vnorm1[i+1] );				// normala pre 2. bod
		glTexCoord2f(text_x[i+1],text_y[1]);	// suradnice na texture, ktore sa maju zobrazit na 2. bod
		glVertex3fv(   bod1[i+1] );				// druhy bod - je v pravom dolnom rohu stvorca
		glNormal3fv( vnorm1[i] );				// normalovy vektor pre 3. bod
		glTexCoord2f(text_x[i],text_y[1]);		// suredniece textury, ktore sa zobrazia na 3. bod
		glVertex3fv(   bod1[i] );				// treti bod - je v pravom hornom (vrchnom) rohu stvorca
		glNormal3fv( vnorm0[i] );				// normalovy v
		glTexCoord2f(text_x[i],text_y[0]);		// suradnice textury
		glVertex3fv(   bod0[i] );				// stvrty bod - je v lavom hornom bode stvorca
	}
	glNormal3fv( vnorm0[0] );					// posledny stvorec ktoreho suradnice su na zaciatku t.j. ako pre uhol=0
	glTexCoord2f( 0,text_y[0]);
	glVertex3fv(   bod0[0] );					// suradnice 0 teho bodu: bod0[delenie_uhla] = bod0[0]
	glNormal3fv( vnorm1[0] );
	glTexCoord2f( 0,text_y[1]);
	glVertex3fv(   bod1[0] );					// suradnice dolneho praceho bodu
	glNormal3fv( vnorm1[delenie_uhla-1] );
	glTexCoord2f(text_x[delenie_uhla-1],text_y[1]);
	glVertex3fv(   bod1[delenie_uhla-1] );		// suradnice posledneho bodu v pravo (hore vpravo na texture)
	glNormal3fv( vnorm0[delenie_uhla-1] );
	glTexCoord2f(text_x[delenie_uhla-1],text_y[0]);
	glVertex3fv(   bod0[delenie_uhla-1] );		// suradnice posledneho bodu v lavo (hore vpravo na texture )
	//glEnd();
	
	// TERAZ vypocitame a nakreslime vsetky pasy okrem posledneho
	for(j=1;j<(delenie_dlzky-1);j++)
	{
		t0 = ( (float) j / (float) delenie_dlzky );
		text_y[0]=1-t0;					// vypocet y suradnice na texture
		t1 = ( (float) (j+1) / (float) delenie_dlzky );
		text_y[1]=1-t1;					// vypocet y suradnice na texture
		t2 = ( (float) (j+2) / (float) delenie_dlzky );
		RiadiacaKrivka(t2,krivka2);
	
		// pole bodov 1 a 2 z predchadzajuceho vypoctu su take iste ako polia bodov 0 a 1, ktore by sme pocitaly v tomto cykle
		// polia bodov preto posunieme a vypocitame iba pole bodov 2
		pomocny = bod0;
		bod0 = bod1;		// vymena poli vrcholov
		bod1 = bod2;
		bod2 = pomocny;
		for(i=0;i<delenie_uhla;i++)
		{
			uhol = PI180 * 360.0f * ( (float) i / (float) delenie_uhla );

			bod2[i][0] = krivka2[0];
			bod2[i][1] = krivka2[1] * (float) cos( uhol ) - krivka2[2] * (float) sin( uhol );
			bod2[i][2] = krivka2[1] * (float) sin( uhol ) + krivka2[2] * (float) cos( uhol );
		}
		// lavy pas stvorcov, ktorych normalove vektory sme vypocitali v predchadzajucom cykle
		// je taky isty ako pravy pas, preto normalove vektory norm0 nemusime pocitat 
		pomocny = norm0;
		norm0 = norm1;
		norm1 = pomocny;
		for(i=0;i<delenie_uhla;i++)				// vypocet normalovych vektorov
		{
			if(i == (delenie_uhla-1) )
			{	// vypocet vektora					 bod1[i]  bod2[i]
				a[0] = bod1[0][0] - bod1[i][0];		//	+----->
				a[1] = bod1[0][1] - bod1[i][1];		//	|     b
				a[2] = bod1[0][2] - bod1[i][2];		//	|
			}										//	V a -bod1[i+1]
			else
			{
				a[0] = bod1[i+1][0] - bod1[i][0];
				a[1] = bod1[i+1][1] - bod1[i][1];
				a[2] = bod1[i+1][2] - bod1[i][2];
			}
	
			b[0] = bod2[i][0] - bod1[i][0];
			b[1] = bod2[i][1] - bod1[i][1];
			b[2] = bod2[i][2] - bod1[i][2];
		
			norm1[i][0] = a[1]*b[2] - a[2]*b[1];		// vektorovy sucin vektorov a, b
			norm1[i][1] = a[2]*b[0] - a[0]*b[2];		// vysledok je vektor kolmy na obidve vektory (a,b)
			norm1[i][2] = a[0]*b[1] - a[1]*b[0];		// vysledok je normalovy vektor stvorca bod1[i+1], bod2[i+1], bod2[i], bod1[i]
			// vypocet velkosti vektora
			absolut = (float) sqrt(norm1[i][0]*norm1[i][0]+norm1[i][1]*norm1[i][1]+norm1[i][2]*norm1[i][2]);
			if(absolut>0)		// zabezpecenie proti deleniu nulov
			{
				norm1[i][0] = norm1[i][0]/absolut;		// urobime z normaloveho vektora jednotkovy (z velkostou 1)
				norm1[i][1] = norm1[i][1]/absolut;
				norm1[i][2] = norm1[i][2]/absolut;
			}
		}
		pomocny = vnorm0;	// vypocet vyhladenych normalovych vektorov pre body bod0[i] nemusime pocitat, lebo su to tie iste ako v predchadzajucom kroku pre body bod[1][i]
		vnorm0 = vnorm1;	// lebo su to tie iste ako v predchadzajucom kroku pre body bod[1][i]
		vnorm1 = pomocny;
		for(i=1;i<delenie_uhla;i++)			// vypocet vyhladenych normalovych vektorov
		{
			vnorm1[i][0]=( norm0[i-1][0] + norm0[i][0] + norm1[i-1][0] + norm1[i][0] )/4.0f;
			vnorm1[i][1]=( norm0[i-1][1] + norm0[i][1] + norm1[i-1][1] + norm1[i][1] )/4.0f;
			vnorm1[i][2]=( norm0[i-1][2] + norm0[i][2] + norm1[i-1][2] + norm1[i][2] )/4.0f;
		}
		vnorm1[0][0]=( norm0[delenie_uhla-1][0] + norm0[0][0] + norm1[delenie_uhla-1][0] + norm1[0][0] )/4.0f;
		vnorm1[0][1]=( norm0[delenie_uhla-1][1] + norm0[0][1] + norm1[delenie_uhla-1][1] + norm1[0][1] )/4.0f;
		vnorm1[0][2]=( norm0[delenie_uhla-1][2] + norm0[0][2] + norm1[delenie_uhla-1][2] + norm1[0][2] )/4.0f;

		//glBegin(GL_QUADS);
		for(i=0;i<(delenie_uhla-1);i++)		// kreslime pas stvorcov zo suradnicami bodov bod0[i] a bod1[i]
		{
			glNormal3fv( vnorm0[i+1] );				// normalovy vektor pre prvy bod v stvorci
			glTexCoord2f(text_x[i+1],text_y[0]);	// texturove suradnice pre prvy bod v stvorci
			glVertex3fv(   bod0[i+1] );				// prvy bod v stvorci - je v lavo dolnom rohu stvorca 
			glNormal3fv( vnorm1[i+1] );				// normala pre 2. bod
			glTexCoord2f(text_x[i+1],text_y[1]);	// suradnice na texture, ktore sa maju zobrazit na 2. bod
			glVertex3fv(   bod1[i+1] );				// druhy bod - je v pravom dolnom rohu stvorca
			glNormal3fv( vnorm1[i] );				// normalovy vektor pre 3. bod
			glTexCoord2f(text_x[i],text_y[1]);		// suredniece textury, ktore sa zobrazia na 3. bod
			glVertex3fv(   bod1[i] );				// treti bod - je v pravom hornom (vrchnom) rohu stvorca
			glNormal3fv( vnorm0[i] );				// normalovy v
			glTexCoord2f(text_x[i],text_y[0]);		// suradnice textury
			glVertex3fv(   bod0[i] );				// stvrty bod - je v lavom hornom bode stvorca
		}
		glNormal3fv( vnorm0[0] );					// posledny stvorec ktoreho suradnice su na zaciatku t.j. ako pre uhol=0
		glTexCoord2f( 0,text_y[0]);
		glVertex3fv(   bod0[0] );					// suradnice 0 teho bodu: bod0[delenie_uhla] = bod0[0]
		glNormal3fv( vnorm1[0] );
		glTexCoord2f( 0,text_y[1]);
		glVertex3fv(   bod1[0] );					// suradnice dolneho praceho bodu
		glNormal3fv( vnorm1[delenie_uhla-1] );
		glTexCoord2f(text_x[delenie_uhla-1],text_y[1]);
		glVertex3fv(   bod1[delenie_uhla-1] );		// suradnice posledneho bodu v pravo (hore vpravo na texture)
		glNormal3fv( vnorm0[delenie_uhla-1] );
		glTexCoord2f(text_x[delenie_uhla-1],text_y[0]);
		glVertex3fv(   bod0[delenie_uhla-1] );		// suradnice posledneho bodu v lavo (hore vpravo na texture )
		//glEnd();
	}

	// TERAZ vypocitame a nakreslime posledny pas stvorcov
	//	normalove vektory pre body bod[x][0][] vypocitame :
	//	norm1[0][]
	//				vnorm0[1][]			--	vyhladeny normalovy vektor pre bod0[1][] 
	//	norm1[1][]
	// vyhladene vektory pre bod1[i] pozname
	pomocny = vnorm0;
	vnorm0 = vnorm1;
	vnorm1 = pomocny;
	for(i=1;i<delenie_uhla;i++)			// vypocet vyhladenych normalovych vektorov pre body bod2[i]
	{
		vnorm1[i][0]=( norm1[i-1][0] + norm1[i][0] )/3.0f;
		vnorm1[i][1]=( norm1[i-1][1] + norm1[i][1] )/3.0f;
		vnorm1[i][2]=( norm1[i-1][2] + norm1[i][2] -1.0f)/3.0f;
	}
	vnorm1[0][0]=( norm1[delenie_uhla-1][0] + norm1[0][0] )/3.0f;
	vnorm1[0][1]=( norm1[delenie_uhla-1][1] + norm1[0][1] )/3.0f;
	vnorm1[0][2]=( norm1[delenie_uhla-1][2] + norm1[0][2] -1.0f)/3.0f;
/*	for(i=1;i<delenie_uhla;i++)			// vypocet vyhladenych normalovych vektorov pre body bod2[i]
	{
		vnorm1[i][0]=( norm1[i-1][0] + norm1[i][0] )/2.0f;
		vnorm1[i][1]=( norm1[i-1][1] + norm1[i][1] )/2.0f;
		vnorm1[i][2]=( norm1[i-1][2] + norm1[i][2] )/2.0f;
	}
	vnorm1[0][0]=( norm1[delenie_uhla-1][0] + norm1[0][0] )/2.0f;
	vnorm1[0][1]=( norm1[delenie_uhla-1][1] + norm1[0][1] )/2.0f;
	vnorm1[0][2]=( norm1[delenie_uhla-1][2] + norm1[0][2] )/2.0f;
*/
	//glBegin(GL_QUADS);
	for(i=0;i<(delenie_uhla-1);i++)		// kreslime posledny pas stvorcov, t.j. medzi bodmi bod1[] a bod2[]
	{
		glNormal3fv( vnorm0[i+1] );
		glTexCoord2f(text_x[i+1],text_y[1]);
		glVertex3fv(   bod1[i+1] );
		glNormal3fv( vnorm1[i+1] );
		glTexCoord2f(text_x[i+1],0);
		glVertex3fv(   bod2[i+1] );
		glNormal3fv( vnorm1[i] );
		glTexCoord2f(text_x[i],0);
		glVertex3fv(   bod2[i] );
		glNormal3fv( vnorm0[i] );
		glTexCoord2f(text_x[i],text_y[1]);
		glVertex3fv(   bod1[i] );
	}
	glNormal3fv( vnorm0[0] );
	glTexCoord2f( 0,text_y[1]);
	glVertex3fv(   bod1[0] );
	glNormal3fv( vnorm1[0] );
	glTexCoord2f( 0,0);
	glVertex3fv(   bod2[0] );
	glNormal3fv( vnorm1[delenie_uhla-1] );
	glTexCoord2f(text_x[delenie_uhla-1],0);
	glVertex3fv(   bod2[delenie_uhla-1] );
	glNormal3fv( vnorm0[delenie_uhla-1] );
	glTexCoord2f(text_x[delenie_uhla-1],text_y[1]);
	glVertex3fv(   bod1[delenie_uhla-1] );
	glEnd();

	delete[] bod0;			// uvolnujeme pamet
	delete[] bod1;
	delete[] bod2;
	delete[] norm0;
	delete[] norm1;
	delete[] vnorm0;
	delete[] vnorm1;
	delete[] text_x;
}
